/**
*	R8C/TinyEEPROMANZX
*	2007.10.14	Junnichi Tomaru
*/
#include	"r8c1b.h"

/* EEPROM֘A` */
#define	A_START		(( unsigned char * )0x2400)
#define	A_END		(( unsigned char * )0x27ff)
#define	B_START		(( unsigned char * )0x2800)
#define	B_END		(( unsigned char * )0x2bff)

#define	_di()	asm( "FCLR I" );	/* 荞݋֎~ */
#define	_ei()	asm( "FSET I" );	/* 荞݋ */

/**
*	EEPROMǂݏo
*	 in	addr	AhX(0000`2047)
*			(A:0000`1023, B:1024`2047)
*		data	i[obt@|C^
*		cnt	oCg
*	out	Ȃ
*/
void	read_eeprom( int addr, char *data, int cnt )
{
	unsigned char	*adr;
	int	i;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	adr = A_START + addr;
	*adr = 0xff;	/* ǂݏoR}h */
	for( i = 0; i < cnt; i++, data++, adr++ ){
		*data = *adr;
	}
	_ei( );
	FMR01 = 0;	/* ANZX֎~ */
}


/**
*	EEPROM
*	 in	addr	AhX(0000`2047)
*			(A:0000`1023, B:1024`2047)
*		data	f[^
*		cnt	
*	out	1:  0:G[
*/
char	write_eeprom( int addr, char *data, int cnt )
{
	unsigned char	*adr;
	int	i;
	char	ret;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	*adr = 0x50;	/* Xe[^XNA */
	adr = A_START + addr;
	for( i = 0; i < cnt; i++, data++, adr++ ){
		*adr = 0x40;	/* ݃R}h */
		*adr = *data;
		while( FMR00 == 0 );	/* ҂ */
		ret = !FMR06;	/* G[`FbN */
		if( ret == 0 ){
			break;
		}
	}
	FMR01 = 0;	/* ANZX֎~ */
	_ei( );

	return	ret;
}


/**
*	EEPROMubN
*	 in	AhX
*	out	1:I  0:G[
*/
char	erase_eeprom( int addr )
{
	unsigned char	*adr, *adr2;
	char	ret;

	_di( );
	FMR01 = 0;	/* U݋֎~ */
	FMR01 = 1;	/* ݋ */
	FMR11 = 0;	/* UEW0ɂ */
	FMR11 = 1;	/* EW1 */

	adr = A_START + addr;
	adr2 = A_END + addr;
	*adr = 0x20;
	*adr2 = 0xd0;
	while( FMR00 == 0 );	/* I҂ */
	ret = FMR07;
	FMR01 = 0;	/* ݋֎~ */
	_ei( );

	return	ret;
}


/* end of eeprom.c */
